**Table A‑3. Mechanism for cb6mp_ae6_aq uses the following species.**

| **Model Species** | **Name**                                                                     | **Molecular Weight** | **Explicit or Lumped** |
|-----------------| ---------------------------------------------------------------------------- | -------------------- | ---------------------- |
| AACD              | acetic acid                                                                  | 60                   | E                      |
| ACET              | acetone                                                                      | 58.1                 | E                      |
| ACRO_PRIMARY      | acrolein from emissions only                                                 | 56.1                 | E                      |
| ACROLEIN          | acrolein                                                                     | 56.1                 | E                      |
| ALD2              | acetaldehyde                                                                 | 44                   | E                      |
| ALD2_PRIMARY      | acetaldehyde from emissions only                                             | 44                   | E                      |
| ALDX              | aldehydes with 3 or more carbons                                             | 58.1                 | L                      |
| ALKRXN            | counter species for aerosol from SOAALK                                      | 112                  | L                      |
| BENZENE           | benzene                                                                      | 78.1                 | E                      |
| BENZRO2           | counter species for aerosol from benzene+OH                                  | 127                  | L                      |
| BNZHRXN           | counter species for aerosol from hydroperoxybenzene                          | 127                  | L                      |
| BNZNRXN           | counter species for aerosol from nitrobenzene                                | 127                  | L                      |
| BUTADIENE13       | 1,3-butadiene                                                                | 54                   | E                      |
| BZO2              | peroxy radical from beneze reactions with OH                                 | 159.1                | L                      |
| C2O3              | acetylperoxy radical                                                         | 75                   | E                      |
| CAT1              | methyl catechols                                                             | 124.1                | L                      |
| CL                | atomic chlorine                                                              | 35.5                 | E                      |
| CL2               | molecular chlorine                                                           | 71                   | E                      |
| CLNO2             | nitryl chloride                                                              | 81.5                 | E                      |
| CLO               | chlorine monoxide                                                            | 51.5                 | E                      |
| CO                | carbon monoxide                                                              | 28                   | E                      |
| CRES              | cresol and higher molecular weight phenols                                   | 108.1                | L                      |
| CRO               | alkoxy radical from cresol                                                   | 107.1                | L                      |
| CRON              | nitro-cresols                                                                | 153.1                | L                      |
| CXO3              | acetylperoxy radicals with 3 or more carbons                                 | 89                   | L                      |
| ECH4              | methane                                                                      | 16                   | E                      |
| EPOX              | isoprene epoxydiol                                                           | 118.1                | L                      |
| EPX2              | peroxy radical from EPOX+OH reaction                                         | 149.1                | L                      |
| ETH               | ethene                                                                       | 28                   | E                      |
| ETHA              | ethane                                                                       | 30.1                 | E                      |
| ETHY              | ethyne (acetylene)                                                           | 26                   | E                      |
| ETOH              | ethanol                                                                      | 46.1                 | E                      |
| FACD              | formic acid                                                                  | 46                   | E                      |
| FMCL              | formylchloride                                                               | 64.5                 | E                      |
| FORM              | formaldehyde                                                                 | 30                   | E                      |
| FORM_PRIMARY      | formaldehyde from emissions only                                             | 30                   | E                      |
| GLY               | glyoxal                                                                      | 58                   | E                      |
| GLYD              | glycoaldehyde (hydroxyacetaldehyde)                                          | 60                   | E                      |
| H2NO3PIJ          | tracer producing HNO3 or ClNO2 from N2O5 in fine mode aerosols               | 64                   | E                      |
| H2NO3PK           | tracer producing HNO3 or ClNO2 from N2O5 in coarse mode aerosols             | 64                   | E                      |
| H2O2              | hydrogen peroxide                                                            | 34                   | E                      |
| HCL               | hydrochloric acid                                                            | 36.5                 | E                      |
| HCO3              | radical from HO2 reactions with formaldehyde                                 | 63                   | E                      |
| HG                | elemental mercury                                                            | 200.6                | E                      |
| HGIIAER           | precursor of aerosol divalent mercury                                        | 200.6                | E                      |
| HGIIGAS           | divalent mercury                                                             | 200.6                | E                      |
| HNO3              | nitric acid                                                                  | 63                   | E                      |
| HO2               | hydroperoxy radical                                                          | 33                   | E                      |
| HOCL              | hypochlorous acid                                                            | 52.5                 | E                      |
| HONO              | nitrous acid                                                                 | 47                   | E                      |
| HPLD              | hydroperoxyaldehyde from ISO2 isomerization                                  | 116.1                | L                      |
| INTR              | nitrate from isoprene                                                        | 147.1                | L                      |
| IOLE              | internal alkene bond                                                         | 56.1                 | L                      |
| ISO2              | isoprene peroxy radical                                                      | 117.1                | L                      |
| ISOP              | isoprene                                                                     | 68.1                 | E                      |
| ISOPRXN           | counter species for aerosol from isoprene, volatility pathways               | 68.1                 | L                      |
| ISPD              | isoprene reaction products (methacrolein, methylvinyl ketone, others)        | 70.1                 | L                      |
| ISPX              | hydroperoxide from ISO2 reaction with HO2                                    | 118.1                | L                      |
| KET               | carbon-ketone bond                                                           | 72.1                 | L                      |
| MEO2              | methylperoxy radical                                                         | 47                   | E                      |
| MEOH              | methanol                                                                     | 32                   | E                      |
| MEPX              | methylhydroperoxide                                                          | 48                   | E                      |
| MGLY              | methyl glyoxal                                                               | 72                   | E                      |
| N2O5              | dinitrogen pentoxide                                                         | 108                  | E                      |
| NAPH              | naphthalene                                                                  | 128.2                | E                      |
| NO                | nitric oxide                                                                 | 30                   | E                      |
| NO2               | nitrogen dioxide                                                             | 46                   | E                      |
| NO3               | nitrate radical                                                              | 62                   | E                      |
| NTR1              | monofunctional organic nitrates                                              | 119.1                | L                      |
| NTR2              | multifunctional organic nitrates                                             | 135.1                | L                      |
| O                 | ground-state oxygen atoms, O(3P)                                             | 16                   | E                      |
| O1D               | electronically excited oxygen atoms, O(1D)                                   | 16                   | E                      |
| O3                | ozone                                                                        | 48                   | E                      |
| OH                | hydroxyl radical                                                             | 17                   | E                      |
| OLE               | terminal alkene bond                                                         | 42.1                 | L                      |
| OPAN              | peroxyacylnitrate from OPO3                                                  | 161                  | L                      |
| OPEN              | aromatic ring opening product (an alkene and aldehyde)                       | 84                   | L                      |
| OPO3              | peroxyacyl radical from OPEN                                                 | 115                  | L                      |
| PACD              | peroxycarboxylic acids                                                       | 76                   | L                      |
| PAHHRXN           | counter species for aerosol from hydroperoxy-PAHs                            | 187.2                | L                      |
| PAHNRXN           | counter species for aerosol from nitro-PAHs                                  | 187.2                | L                      |
| PAHRO2            | counter species for aerosol from NAPH+OH                                     | 187.2                | L                      |
| PAN               | peroxyacylnitrate                                                            | 121                  | E                      |
| PANX              | peroxyacylnitrates with 3 or more carbons                                    | 135                  | L                      |
| PAR               | carbon-carbon single bond                                                    | 72.1                 | L                      |
| PCSOARXN          | counter species for potential aerosol from combustion (from PCVOC reactions) | 170                  | L                      |
| PCVOC             | tracer for potential combustion SOA VOCs                                     | 170                  | L                      |
| PNA               | peroxynitric acid                                                            | 79                   | E                      |
| PRPA              | propane                                                                      | 44.1                 | E                      |
| RO2               | total peroxy radical concentration                                           | 87.1                 | L                      |
| ROOH              | methylhydroperoxide                                                          | 90.1                 | E                      |
| ROR               | secondary alkoxy radical                                                     | 71.1                 | L                      |
| SESQ              | sesquiterpenes                                                               | 204                  | L                      |
| SESQRXN           | counter species for aerosol from sesquiterpenes                              | 204                  | L                      |
| SO2               | sulfur dioxide                                                               | 64                   | E                      |
| SOAALK            | tracer for alkanes that can form secondary organic aerosol                   | 112                  | L                      |
| SULF              | sulfuric acid (gaseous)                                                      | 98                   | E                      |
| SULRXN            | sulfate aerosol precursor                                                    | 98                   | E                      |
| TERP              | monoterpenes                                                                 | 136.2                | L                      |
| TO2               | toluene peroxy radical                                                       | 173.1                | L                      |
| TOL               | toluene and other monoalkyl aromatics                                        | 92.1                 | L                      |
| TOLHRXN           | counter species for aerosol from hydroperoxytoluene                          | 141                  | L                      |
| TOLNRXN           | counter species for aerosol from nitrotoluene                                | 141                  | L                      |
| TOLRO2            | counter species for aerosol from TOL+OH                                      | 141                  | L                      |
| TOLU              | toluene                                                                      | 92                   | E                      |
| TRPRXN            | counter species for aerosol precursor from monoterpenes                      | 136.2                | L                      |
| VIVPO1            | evaporated primary organic aerosol, intermed-volatility                      | 266                  | L                      |
| VLVOO1            | evaporated secondary organic aerosol, low-volatility, cat 1                  | 136                  | L                      |
| VLVOO2            | evaporated secondary organic aerosol, low-volatility, cat 2                  | 136                  | L                      |
| VLVPO1            | evaporated primary organic aerosol, low-volatility                           | 218                  | L                      |
| VSVOO1            | evaporated secondary organic aerosol, semi-volatile, cat 1                   | 135                  | L                      |
| VSVOO2            | evaporated secondary organic aerosol, semi-volatile, cat 2                   | 135                  | L                      |
| VSVOO3            | evaporated secondary organic aerosol, semi-volatile, cat 3                   | 134                  | L                      |
| VSVPO1            | evaporated primary organic aerosol, semi-volatile, cat 1                     | 230                  | L                      |
| VSVPO2            | evaporated primary organic aerosol, semi-volatile, cat 2                     | 241                  | L                      |
| VSVPO3            | evaporated primary organic aerosol, semi-volatile, cat 3                     | 253                  | L                      |
| XLO2              | peroxy radical from XYLMN+OH reaction                                        | 187.1                | L                      |
| XO2               | NO oxidation to NO2 via peroxy radical                                       | 87.1                 | L                      |
| XO2H              | NO oxidation to NO2 with HO2 production, from alkoxy radicals                | 87.1                 | L                      |
| XO2N              | nitrate production from NO reaction with peroxy radical                      | 87.1                 | L                      |
| XOPN              | product of aromatic ring-opening reaction                                    | 98.1                 | L                      |
| XPAR              | organic nitrate production from PAR                                          | 117.1                | L                      |
| XPRP              | organic nitrate production from PRPA                                         | 89.1                 | L                      |
| XYLHRXN           | counter species for aerosol from hydroperoxy xylene                          | 155                  | L                      |
| XYLMN             | xylene and other polyalkyl aromatics except naphthalene                      | 106.2                | L                      |
| XYLNRXN           | counter species for aerosol from nitroxylene                                 | 155                  | L                      |
| XYLRO2            | counter species for aerosol from XYLMN+OH                                    | 155                  | L                      |
