**The GC namelist for cb6r3_ae6_aq has the following gas phase species.**

| **Model Species** | **Definition**                                                                     | **Molecular Weight** | **Explicit or Lumped** |
| ----------------- | ---------------------------------------------------------------------------- | -------------------- | ---------------------- |
| AACD              | acetic acid                                                                  | 60                   | E                      |
| ACET              | acetone                                                                      | 58.1                 | E                      |
| ACRO_PRIMARY      | acrolein from emissions only                                                 | 56.1                 | E                      |
| ACROLEIN          | acrolein                                                                     | 56.1                 | E                      |
| ALD2              | acetaldehyde                                                                 | 44                   | E                      |
| ALD2_PRIMARY      | acetaldehyde from emissions only                                             | 44                   | E                      |
| ALDX              | aldehydes with 3 or more carbons                                             | 58.1                 | L                      |
| ALKRXN            | counter species for aerosol from SOAALK                                      | 112                  | L                      |
| BENZENE           | benzene                                                                      | 78.1                 | E                      |
| BENZRO2           | counter species for aerosol from benzene+OH                                  | 127                  | L                      |
| BNZHRXN           | counter species for aerosol from hydroperoxybenzene                          | 127                  | L                      |
| BNZNRXN           | counter species for aerosol from nitrobenzene                                | 127                  | L                      |
| BUTADIENE13       | 1,3-butadiene                                                                | 54                   | E                      |
| BZO2              | peroxy radical from beneze reactions with OH                                 | 159.1                | L                      |
| C2O3              | acetylperoxy radical                                                         | 75                   | E                      |
| CAT1              | methyl catechols                                                             | 124.1                | L                      |
| CL                | atomic chlorine                                                              | 35.5                 | E                      |
| CL2               | molecular chlorine                                                           | 71                   | E                      |
| CLNO2             | nitryl chloride                                                              | 81.5                 | E                      |
| CLNO3             | chlorine nitrate                                                             | 97.5                 | E                      |
| CLO               | chlorine monoxide                                                            | 51.5                 | E                      |
| CO                | carbon monoxide                                                              | 28                   | E                      |
| CRES              | cresol and higher molecular weight phenols                                   | 108.1                | L                      |
| CRO               | alkoxy radical from cresol                                                   | 107.1                | L                      |
| CRON              | nitro-cresols                                                                | 153.1                | L                      |
| CXO3              | acetylperoxy radicals with 3 or more carbons                                 | 89                   | L                      |
| ECH4              | methane                                                                      | 16                   | E                      |
| EPOX              | isoprene epoxydiol                                                           | 118.1                | L                      |
| EPX2              | peroxy radical from EPOX+OH reaction                                         | 149.1                | L                      |
| ETH               | ethene                                                                       | 28                   | E                      |
| ETHA              | ethane                                                                       | 30.1                 | E                      |
| ETHY              | ethyne (acetylene)                                                           | 26                   | E                      |
| ETOH              | ethanol                                                                      | 46.1                 | E                      |
| FACD              | formic acid                                                                  | 46                   | E                      |
| FMCL              | formylchloride                                                               | 64.5                 | E                      |
| FORM              | formaldehyde                                                                 | 30                   | E                      |
| FORM_PRIMARY      | formaldehyde from emissions only                                             | 30                   | E                      |
| GLY               | glyoxal                                                                      | 58                   | E                      |
| GLYD              | glycoaldehyde (hydroxyacetaldehyde)                                          | 60                   | E                      |
| H2NO3PIJ          | tracer producing HNO3 or ClNO2 from N2O5 in fine mode aerosols               | 64                   | E                      |
| H2NO3PK           | tracer producing HNO3 or ClNO2 from N2O5 in coarse mode aerosols             | 64                   | E                      |
| H2O2              | hydrogen peroxide                                                            | 34                   | E                      |
| HCL               | hydrochloric acid                                                            | 36.5                 | E                      |
| HCO3              | radical from HO2 reactions with formaldehyde                                 | 63                   | E                      |
| HG                | elemental mercury                                                            | 200.6                | E                      |
| HGIIAER           | precursor of aerosol divalent mercury                                        | 200.6                | E                      |
| HGIIGAS           | divalent mercury                                                             | 200.6                | E                      |
| HNO3              | nitric acid                                                                  | 63                   | E                      |
| HO2               | hydroperoxy radical                                                          | 33                   | E                      |
| HOCL              | hypochlorous acid                                                            | 52.5                 | E                      |
| HONO              | nitrous acid                                                                 | 47                   | E                      |
| HPLD              | hydroperoxyaldehyde from ISO2 isomerization                                  | 116.1                | L                      |
| INTR              | nitrate from isoprene                                                        | 147.1                | L                      |
| IOLE              | internal alkene bond                                                         | 56.1                 | L                      |
| ISO2              | isoprene peroxy radical                                                      | 117.1                | L                      |
| ISOP              | isoprene                                                                     | 68.1                 | E                      |
| ISOPRXN           | counter species for aerosol from isoprene, volatility pathways               | 68.1                 | L                      |
| ISPD              | isoprene reaction products (methacrolein, methylvinyl ketone, others)        | 70.1                 | L                      |
| ISPX              | hydroperoxide from ISO2 reaction with HO2                                    | 118.1                | L                      |
| KET               | carbon-ketone bond                                                           | 72.1                 | L                      |
| MEO2              | methylperoxy radical                                                         | 47                   | E                      |
| MEOH              | methanol                                                                     | 32                   | E                      |
| MEPX              | methylhydroperoxide                                                          | 48                   | E                      |
| MGLY              | methyl glyoxal                                                               | 72                   | E                      |
| N2O5              | dinitrogen pentoxide                                                         | 108                  | E                      |
| NAPH              | naphthalene                                                                  | 128.2                | E                      |
| NO                | nitric oxide                                                                 | 30                   | E                      |
| NO2               | nitrogen dioxide                                                             | 46                   | E                      |
| NO3               | nitrate radical                                                              | 62                   | E                      |
| NTR1              | monofunctional organic nitrates                                              | 119.1                | L                      |
| NTR2              | multifunctional organic nitrates                                             | 135.1                | L                      |
| O                 | ground-state oxygen atoms, O(3P)                                             | 16                   | E                      |
| O1D               | electronically excited oxygen atoms, O(1D)                                   | 16                   | E                      |
| O3                | ozone                                                                        | 48                   | E                      |
| OH                | hydroxyl radical                                                             | 17                   | E                      |
| OLE               | terminal alkene bond                                                         | 42.1                 | L                      |
| OPAN              | peroxyacylnitrate from OPO3                                                  | 161                  | L                      |
| OPEN              | aromatic ring opening product (an alkene and aldehyde)                       | 84                   | L                      |
| OPO3              | peroxyacyl radical from OPEN                                                 | 115                  | L                      |
| PACD              | peroxycarboxylic acids                                                       | 76                   | L                      |
| PAHHRXN           | counter species for aerosol from hydroperoxy-PAHs                            | 187.2                | L                      |
| PAHNRXN           | counter species for aerosol from nitro-PAHs                                  | 187.2                | L                      |
| PAHRO2            | counter species for aerosol from NAPH+OH                                     | 187.2                | L                      |
| PAN               | peroxyacylnitrate                                                            | 121                  | E                      |
| PANX              | peroxyacylnitrates with 3 or more carbons                                    | 135                  | L                      |
| PAR               | carbon-carbon single bond                                                    | 72.1                 | L                      |
| PCSOARXN          | counter species for potential aerosol from combustion (from PCVOC reactions) | 170                  | L                      |
| PCVOC             | tracer for potential combustion SOA VOCs                                     | 170                  | L                      |
| PNA               | peroxynitric acid                                                            | 79                   | E                      |
| PRPA              | propane                                                                      | 44.1                 | E                      |
| RO2               | total peroxy radical concentration                                           | 87.1                 | L                      |
| ROOH              | methylhydroperoxide                                                          | 90.1                 | E                      |
| ROR               | secondary alkoxy radical                                                     | 71.1                 | L                      |
| SESQ              | sesquiterpenes                                                               | 204                  | L                      |
| SESQRXN           | counter species for aerosol from sesquiterpenes                              | 204                  | L                      |
| SO2               | sulfur dioxide                                                               | 64                   | E                      |
| SOAALK            | tracer for alkanes that can form secondary organic aerosol                   | 112                  | L                      |
| SULF              | sulfuric acid (gaseous)                                                      | 98                   | E                      |
| SULRXN            | sulfate aerosol precursor                                                    | 98                   | E                      |
| TERP              | monoterpenes                                                                 | 136.2                | L                      |
| TO2               | toluene peroxy radical                                                       | 173.1                | L                      |
| TOL               | toluene and other monoalkyl aromatics                                        | 92.1                 | L                      |
| TOLHRXN           | counter species for aerosol from hydroperoxytoluene                          | 141                  | L                      |
| TOLNRXN           | counter species for aerosol from nitrotoluene                                | 141                  | L                      |
| TOLRO2            | counter species for aerosol from TOL+OH                                      | 141                  | L                      |
| TOLU              | toluene                                                                      | 92                   | E                      |
| TRPRXN            | counter species for aerosol precursor from monoterpenes                      | 136.2                | L                      |
| VIVPO1            | evaporated primary organic aerosol, intermed-volatility                      | 266                  | L                      |
| VLVOO1            | evaporated secondary organic aerosol, low-volatility, cat 1                  | 136                  | L                      |
| VLVOO2            | evaporated secondary organic aerosol, low-volatility, cat 2                  | 136                  | L                      |
| VLVPO1            | evaporated primary organic aerosol, low-volatility                           | 218                  | L                      |
| VSVOO1            | evaporated secondary organic aerosol, semi-volatile, cat 1                   | 135                  | L                      |
| VSVOO2            | evaporated secondary organic aerosol, semi-volatile, cat 2                   | 135                  | L                      |
| VSVOO3            | evaporated secondary organic aerosol, semi-volatile, cat 3                   | 134                  | L                      |
| VSVPO1            | evaporated primary organic aerosol, semi-volatile, cat 1                     | 230                  | L                      |
| VSVPO2            | evaporated primary organic aerosol, semi-volatile, cat 2                     | 241                  | L                      |
| VSVPO3            | evaporated primary organic aerosol, semi-volatile, cat 3                     | 253                  | L                      |
| XLO2              | peroxy radical from XYLMN+OH reaction                                        | 187.1                | L                      |
| XO2               | NO oxidation to NO2 via peroxy radical                                       | 87.1                 | L                      |
| XO2H              | NO oxidation to NO2 with HO2 production, from alkoxy radicals                | 87.1                 | L                      |
| XO2N              | nitrate production from NO reaction with peroxy radical                      | 87.1                 | L                      |
| XOPN              | product of aromatic ring-opening reaction                                    | 98.1                 | L                      |
| XPAR              | organic nitrate production from PAR                                          | 117.1                | L                      |
| XPRP              | organic nitrate production from PRPA                                         | 89.1                 | L                      |
| XYLHRXN           | counter species for aerosol from hydroperoxy xylene                          | 155                  | L                      |
| XYLMN             | xylene and other polyalkyl aromatics except naphthalene                      | 106.2                | L                      |
| XYLNRXN           | counter species for aerosol from nitroxylene                                 | 155                  | L                      |
| XYLRO2            | counter species for aerosol from XYLMN+OH                                    | 155                  | L                      |


**The AE namelist for cb6mp_ae6_aq has the following aerosol species.**

| **Model Species** | **Definition**                                             | **Molecular Weight** | **Explicit or Lumped** |
|--------|-----------------------------------------------------------------|----------------------|------------------------|
| AAL               | Aluminum                                             | 27                   | E                      |
| AALK1             | Semivolaitle SOA Product from Alkane VOCs            | 225.0                | L                      |
| AALK2             | Semivolatile SOA Product from Alkane VOCs            | 205.1                | L                      |
| AAS               | Arsenic                                              | 74.92                | E                      |
| ABE               | Beryllium                                            | 9.0                  | E                      |
| ABNZ1             | Semivolatile High-NOx SOA Product from Benzene       | 161.0                | L                      |
| ABNZ2             | Semivolatile High-NOx SOA Product from Benzene       | 134.0                | L                      |
| ABNZ3             | Low-Volatility Low-NOx SOA Product from Benzene      | 180.0                | L                      |
| ACA               | Calcium                                              | 40.1                 | E                      |
| ACD               | Cadmium                                              | 112.4                | E                      |
| ACL               | Chloride                                             | 35.5                 | E                      |
| ACORS             | Anthropogenic Coarse-mode particle mass              | 100.0                | L                      |
| ACR_III           | Trivalent Chromium                                   | 52.0                 | E                      |
| ACR_VI            | Hexavalent Chromium                                  | 52.0                 | E                      |
| ADE_EC            | Diesel Elemental Carbon                              | 12.0                 | L                      |
| ADE_K             | Diesel Coarse Primary Particles                      | 100.0                | L                      |
| ADE_NO3           | Diesel Nitrate                                       | 62.0                 | E                      |
| ADE_OC            | Diesel Organic Carbon                                | 220.0                | L                      |
| ADE_OTHR          | Other Diesel Fine Primary Particles                  | 200.0                | L                      |
| ADE_SO4           | Diesel Sulfate                                       | 96.0                 | E                      |
| AEC               | Elemental Carbon                                     | 12                   | E                      |
| AFE               | Iron                                                 | 55.8                 | E                      |
| AGLY              | Glyoxal and Methylglyoxal SOA in aqueous aerosol material                       | 66.4                 | L                      |
| AH2O              | Water                                                | 18                   | E                      |
| AH3OP             | Hydronium Ion                                        | 19                   | E                      |
| AISO1             | Semivolatile SOA Product from Isoprene               | 132.0                | L                      |
| AISO2             | High-Volatility SOA Product from Isoprene            | 133.0                | L                      |
| AISO3             | Acid-catalyzed Isoprene Epoxydiol SOA                | 168.2                | L                      |
| AIVPO1            | Intermediate Volatility Primary Organic Compounds    | 266                  | L                      |
| AK                | Potassium                                            | 39.1                 | E                      |
| ALVOO1            | Low Volatility Oxidized Combustion Organic Compounds | 136                  | L                      |
| ALVOO2            | Low Volatility Oxidized Combustion Organic Compounds | 136                  | L                      |
| ALVPO1            | Low Volatility Primary Organic Compounds             | 218                  | L                      |
| AMG               | Magnesium                                            | 24.3                 | E                      |
| AMN               | Manganese                                            | 54.9                 | E                      |
| AMN_HAPS          | Manganese based on the Hazardous Air Pollutant Emissions          | 54.9                 | E                      |
| ANA               | Sodium                                               | 23                   | E                      |
| ANH4              | Ammonium                                             | 18                   | E                      |
| ANI               | Nickel                                               | 58.7                 | E                      |
| ANO3              | Nitrate                                              | 62                   | E                      |
| AOLGA             | Oligomer products of anthropogenic SOA compounds     | 206.0                | L                      |
| AOLGB             | Oligomer products of biogenic SOA compounds          | 248.0                | L                      |
| AORGC             | Glyoxal and methylglyoxal SOA produced in cloud water                        | 177.0                | L                      |
| AOTHR             | Other Particulate Mass                               | 200                  | L                      |
| APAH1             | Semivolatile High-NOx SOA Product from PAHs          | 195.6                | L                      |
| APAH2             | Semivolatile High-NOx  SOA Product from PAHs         | 178.7                | L                      |
| APAH3             | Low-Volatility Low-NOx SOA Product from PAHs         | 212.2                | L                      |
| APB               | Lead                                                 | 207.2                | E                      |
| APCSO             | Potential Combustion SOA                             | 170                  | L                      |
| APHG              | Mercury                                              | 200.5                | E                      |
| APNCOM            | Non-Carbon Organic Matter associated with APOC       | 220.0                | L                      |
| APOC              | Primary Organic Carbon                               | 220.0                | L                      |
| ASEACAT           | Sea spray cations                                    | 23.75                | L                      |
| ASI               | Silicon                                              | 28.1                 | E                      |
| ASO4              | Sulfate                                              | 96                   | E                      |
| ASOIL             | Lumped crustal species                               | 100.0                | L                      |
| ASQT              | Semivolatile SOA Product from Sesquiterpenes         | 273.0                | L                      |
| ASVOO1            | Semivolatile Oxidized Combustion Organic Compounds   | 135                  | L                      |
| ASVOO2            | Semivolatile Oxidized Combustion Organic Compounds   | 135                  | L                      |
| ASVOO3            | Semivolatile Oxidized Combustion Organic Compounds   | 134                  | L                      |
| ASVPO1            | Semivolatile Primary Organic Compounds               | 230                  | L                      |
| ASVPO2            | Semivolatile Primary Organic Compounds               | 241                  | L                      |
| ASVPO3            | Semivolatile Primary Organic Compounds               | 253                  | L                      |
| ATI               | Titanium                                             | 47.9                 | E                      |
| ATOL1             | Semivolatile High-NOx SOA Product from Toluene       | 163.0                | L                      |
| ATOL2             | Semivolaitle High-NOx SOA Product from Toluene       | 175.0                | L                      |
| ATOL3             | Low-Volatility Low-NOx SOA Product from Toluene      | 194.0                | L                      |
| ATRP1             | Semivolatile SOA Product from Monoterpenes           | 177.0                | L                      |
| ATRP2             | High-Volatility SOA Product from Monoterpenes        | 198.0                | L                      |
| AXYL1             | Semivolatile High-NOx SOA Product from Xylene        | 174.0                | L                      |
| AXYL2             | Semivolaitle High-NOx SOA Product from Xylene        | 185.0                | L                      |
| AXYL3             | Low-Volatility Low-NOx SOA Product from Xylene       | 218.0                | L                      |
| NUMACC            | Accum. Mode Number Conc                              | NA                   | NA                     |
| NUMAIT            | Aitken Mode Number Conc                              | NA                   | NA                     |
| NUMCOR            | Coarse Mode Number Conc                              | NA                   | NA                     |
| SRFACC            | Accum. Mode Surface Area Conc                        | NA                   | NA                     |
| SRFAIT            | Aitken Mode Surface Area Conc                        | NA                   | NA                     |
| SRFCOR            | Coarse Mode Surface Area Conc                        | NA                   | NA                     |

Note that for each aerosol mass species, a letter will be appended to the names below in order to designate the size, or mode, of the aerosol being represented: I = Aitken mode, J = Accumulation mode, K = Coarse mode.  


**The NR namelist for cb6mp_ae6_aq has the following gas phase species.**

| **Model Species** | **Definition**                                             | **Molecular Weight** | **Explicit or Lumped** |
| ----------------- | ---------------------------------------------------- | -------------------- | ---------------------- |
|  ACETONITRILE      |  acetonitrile                    |  41.05  |  E  |
|  ACRYACID          |  acrylic acid                    |  72.06  |  E  |
|  ACRYLONITRILE     |  Acrylonitrile                   |  53.10  |  E  |   
|  BR2_C2_12         |  1,2-Dibromoethane               | 187.90  |  E  |   
|  CARBONTET         |  Carbon Tetrachloride            | 153.80  |  E  |   
|  CARBSULFIDE       |  carbonyl sulfide                |  60.10  |  E  |
|  CHLOROPRENE       |  chloroprene                     |  88.50  |  E  |
|  CL2_C2_12         |  1,2-Dichloroethane              |  99.00  |  E  |   
|  CL4_ETHANE1122    |  1,1,2,2-Tetrachloroethane       | 167.90  |  E  |   
|  CL2_ME            |  Methylene Chloride              |  84.90  |  E  |   
|  CL4_ETHE          |  Perchloroethylene               | 165.80  |  E  |   
|  CL3_ETHE          |  Trichloroethylene               | 131.40  |  E  |   
|  CL_ETHE           |  Vinyl Chloride                  |  62.50  |  E  |   
|  CHCL3             |  Chloroform                      | 119.40  |  E  |   
|  DICHLOROBENZENE   |  1,4-Dichlorobenzene             | 147.00  |  E  |   
|  DICHLOROPROPENE   |  1,3-Dichloropropene             |  99.00  |  E  |   
|  ETHYLBENZENE      |  ethyl benzene                   | 106.00  |  E  |
|  ETOX              |  Ethylene Oxide                  |  44.10  |  E  |   
|  HEXANE            |  n-Hexane                        |  86.00  |  E  |
|  HYDRAZINE         |  Hydrazine                       | 168.20  |  E  |   
|  HEXAMETHY_DIIS    |  Hexamethylene 1,6-Diisocyanate  |  98.00  |  E  |   
|   LVPCSOG          |  surrogate SOA precursor gas for combustion/anthropogenic sources           | 170.00  |  L  |  
|  MAL_ANHYDRIDE     |  Maleic Anhydride                | 174.20  |  E  |   
|  METHCHLORIDE      |  methyl chloride                 |  50.40  |  E  |
|  NAPHTHALENE       |  Naphthalene                     | 128.20  |  E  |   
|  NH3               |  ammonia                         |  17.00  |  E  |      
|  PROPDICHLORIDE    |  Propylene Dichloride            | 113.00  |  E  |   
|  QUINOLINE         |  Quinoline                       | 129.20  |  E  |   
|  STYRENE           |  sytrene                         | 104.15  |  E  |
|  SVALK1           |  vapors of secondary aerosol material from alkane VOCs      | 225.00  |  L  |     
|  SVALK2           |  vapors of secondary aerosol material from alkane VOCs      | 205.10  |  L  |     
|  SVXYL1           |  vapors of secondary aerosol material from xylenes          | 174.00  |  L  |  
|  SVXYL2           |  vapors of secondary aerosol material from xylenes          | 185.00  |  L  |  
|  SVTOL1           |  vapors of secondary aerosol material from toluene          | 163.00  |  L  |  
|  SVTOL2           |  vapors of secondary aerosol material from toluene          | 175.00  |  L  |  
|  SVBNZ1           |  vapors of secondary aerosol material from benzene          | 161.00  |  L  |  
|  SVBNZ2           |  vapors of secondary aerosol material from benzene          | 134.00  |  L  |  
|  SVPAH1           |  vapors of secondary aerosol material from PAHs             | 195.60  |  L  |  
|  SVPAH2           |  vapors of secondary aerosol material from PAHs             | 178.70  |  L  |  
|  SVTRP1           |  vapors of secondary aerosol material from monoterpenes     | 177.00  |  L  |      
|  SVTRP2           |  vapors of secondary aerosol material from monoterpenes     | 198.00  |  L  |      
|  SVISO1           |  vapors of secondary aerosol material from isoprene         | 132.00  |  L  |  
|  SVISO2           |  vapors of secondary aerosol material from isoprene         | 133.00  |  L  |  
|  SVSQT            |  vapors of secondary aerosol material from sesquiterpenes   | 273.00  |  L  |         
|  TOL_DIIS          |  2,4-Toluene Diisocyanate        |  32.00  |  E  |   
|  TRIETHYLAMINE     |  Triethylamine                   | 101.20  |  E  |   
|  XYLENE            |  O-,M-, and P-xylene isomers     | 106.20  |  L  |
