**The GC namelist for saprc07tic_ae6i_aq has the following gas phase species.**

| **Definition** | **Definition** | **Explicit or Lumped** | **Molecular Weight** |
|----------|-------------------------------------|----------------|-----------------|
|ACETONE|Acetone|E|58.08 |
|ACETYLENE|Acetylene|E|26.04 |
|ACRO_PRIMARY|Acrolein emissions tracer|E|56.06 |
|ACROLEIN|Acrolein|E|56.06 |
|AFG1|Lumped photoreactive monounsaturated dicarbonyl aromatic fragmentation products that photolyze to form radicals|L|98.1 |
|AFG2|Lumped photoreactive monounsaturated dicarbonyl aromatic fragmentation products that photolyze to form non-radical products|L|98.1 |
|AFG3|Lumped diunsaturatred dicarbonyl aromatic fragmentation product.|L|124.14 |
|ALK1|Alkanes and other non-aromatic compounds that react only with OH, and have kOH between 2 and 5 x 102 ppm-1 min-1.  (Primarily ethane)|L|30.07 |
|ALK2|Alkanes and other non-aromatic compounds that react only with OH, and have kOH between 5 x 102 and 2.5 x 103 ppm-1 min-1. (Primarily propane and acetylene)|L|36.73 |
|ALK3|Alkanes and other non-aromatic compounds that react only with OH, and have kOH between 2.5 x 103 and 5 x 103 ppm-1 min-1.|L|58.61 |
|ALK4|Alkanes and other non-aromatic compounds that react only with OH, and have kOH between 5 x 103 and 1 x 104 ppm-1 min-1.|L|77.6 |
|ALK5|Alkanes and other non-aromatic compounds that react only with OH, and have kOH greater than 1 x 104 ppm-1 min-1.|L|118.89 |
|ALKRXN|Precursor of Terpene Aerosol Material|L|112 |
|APIN|a-pinene|E|136.23 |
|ARO1|Aromatics with kOH < 2x104 ppm-1 min-1.|L|95.16 |
|ARO2MN|ARO2 minus naphthalene|L|118.72 |
|BACL|Biacetyl|E|86.09 |
|BALD|Aromatic aldehydes (e.g., benzaldehyde)|L|106.13 |
|BENZENE|Benzene|E|78.11 |
|BENZRO2|Peroxy radical tracer from Benzene and OH reaction used to produce aerosol material|E|159.11 |
|BNZHRXN|Precursor of Hydro-Benzene Aerosol Material|L|159.11 |
|BNZNRXN|Precursor of Nitro-Benzene Aerosol Material|L|159.11 |
|BUTADIENE13|1,3-butadiene|E|54.09 |
|BZCO3|Peroxyacyl radical formed from Aromatic Aldehydes|L|137.12 |
|BZO|Phenoxy Radicals|L|93 |
|CCHO_PRIMARY|Acetaldehyde Emissions Tracer|E|44.05 |
|CCHO|Acetaldehyde|E|44.05 |
|CCOOH|Acetic Acid. Also used for peroxyacetic acid in Carter|E|60.05 |
|CCOOOH|Proposed for Peroxyacetic Acid|E|76 |
|CL|Chlorine atoms|E|35.5 |
|CL2|Chlorine molecules|E|70 |
|CLACET|Chloroacetone (and other alpha-chloro ketones that are assumed to be similarly photoreactive)|L|92.5 |
|CLCCHO|Chloroacetaldehyde (and other alpha-chloro aldehydes that are assumed to be similarly photoreactive)|L|78.5 |
|CLCHO|Formyl Chloride (assumed to be unreactive)|E|64.5 |
|CLNO|Nitrosyl Chloride|E|65.5 |
|CLNO2|Nitryl Chloride|E|81.5 |
|CLO|Chlorine Monoxide Radicals|E|51.5 |
|CLONO|Nitrous Hypochloride |E|81.5 |
|CLONO2|Chlorine Nitrate|E|97.45 |
|CO|Carbon Monoxide|E|28.01 |
|CO2|Carbon Dioxide|E|44.01 |
|COOH|Methyl Hydroperoxide|E|48.04 |
|CRES|Phenols and Cresols|L|108.14 |
|DHMOB|dihydroxy carbonyl from HC5|L|132.1 |
|DIBOO|peroxy radical from isoprene + OH|L|133.1 |
|ETHENE|Ethene|E|28.05 |
|ETHLN|ethanal nitrate|E|105 |
|ETOH|Ethanol|E|46.07 |
|GLY|Glyoxal|E|58.04 |
|HACET|Hydroxyacetone|E|74.1 |
|HC5|hydroxy carbonyl alkenes from isoprene|L|100.1 |
|HC5OO|peroxy radical from HC5|L|149.1 |
|HCHO_PRIMARY|Formaldehyde Emission Tracer|E|30.03 |
|HCHO|Formaldehyde|E|30.03 |
|HCL|Hydrochloric acid|E|36.5 |
|HCOCO3|acylperoxy radicals from glyoxal|L|89 |
|HCOOH|Formic Acid|E|46.03 |
|HNO3|Nitric Acid|E|63.02 |
|HNO4|Peroxynitric Acid|E|79.02 |
|HO2|Hydroperoxide Radicals|E|33.01 |
|HO2H|Hydrogen Peroxide|E|34.01 |
|HOCCHO|Glycolaldehyde|E|60.05 |
|HOCL|HOCl|E|52.5 |
|HONO|Nitrous Acid|E|47.02 |
|HPALD|hydroperoxymethyl-butenals|L|116.12 |
|IEPOX|dihydroxyepoxides|L|118.13 |
|IEPOXOO|peroxy radical from IEPOX|L|149.12 |
|IEPOXP|peroxy radical from IEPOX|L|118.13 |
|IHMML|Methacrylic acid epoxide|L|102 |
|IHMMLP|Methacrylic acid epoxide|L|102 |
|IMACO3|Peroxyacyl radicals formed from methacrolein + OH abstraction channel|L|101.08 |
|IMAE|Methacryloyl peroxy nitrate|E|102 |
|IMAEP|Methacryloyl peroxy nitrate|E|102 |
|IMAPAN|Methacrylicperoxy acid|E|147.09 |
|IMPAA|Peroxyacyl radicals formed from methacrolein + OH abstraction channel|L|102.08 |
|IPRD|Lumped isoprene product species|L|100.12 |
|ISOPNB|beta-hydroxy isoprene nitrates|L|147.1 |
|ISOPND|delta-hydroxy isoprene nitrates|L|147.1 |
|ISOPNN|second generation isoprene dinitrate from NO3 reaction|L|226 |
|ISOPNOOB|peroxy radical from ISOPNB|L|196.1 |
|ISOPNOOD|peroxy radical from ISOPND|L|196.1 |
|ISOPO2|peroxy radical from isoprene + OH|L|117.1 |
|ISOPOOH|hydroxyhydroperoxides from ISOPO2|L|118.1 |
|ISOPRENE|Isoprene|E|68.12 |
|ISOPRXN|SOA precursor compounds from isoprene|L|68 |
|MACO3|Peroxyacyl radicals formed from methacrolein and other acroleins.|L|101.08 |
|MACR|Methacrolein|E|70.09 |
|MACRN|methacrolein nitrate|E|149.1 |
|MACROO|peroxy radical from MACR|L|119.1 |
|MAPAN|PAN analogue formed from Methacrolein|L|147.09 |
|MECO3|Acetyl Peroxy Radicals|L|75.04 |
|MEK|Ketones and other non-aldehyde oxygenated products which react with OH radicals faster than 5 x 10-13 but slower than 5 x 10-12 cm3 molec-2 sec-1. (Based on mechanism for methyl ethyl ketone).|L|72.11 |
|MEO2|Methyl Peroxy Radicals|L|47.03 |
|MEOH|Methanol|E|32.04 |
|MGLY|Methyl Glyoxal|E|72.07 |
|MTNO3|monoterpene(TERP)-derived organic nitrates (exluding alpha-pinene)|L|231 |
|MVK|Methyl Vinyl Ketone|E|70.09 |
|MVKN|methylvinylketone nitrate|E|149.1 |
|MVKOO|peroxy radical from MVK|L|119.1 |
|MXYL|m-xylene|E|106.17 |
|N2O5|Nitrogen Pentoxide|E|108.02 |
|NAPHTHAL|naphthalene|E|128.2 |
|NISOPO2|peroxy radical from isoprene + NO3|E|162.1 |
|NISOPOOH|hydroperoxide from NISOPO2|E|163.13 |
|NIT1|C5 carbonyl nitrates|L|145.1 |
|NIT1NO3OOA|acyl peroxy radical from NIT1 + NO3 (abstraction of aldehydic H)|L|176.1 |
|NIT1NO3OOB|peroxy radical from NIT1 + NO3 (addition to double bond)|L|239.1 |
|NIT1OHOO|peroxy radical from NIT1 + OH|L|194.12 |
|NO|Nitric Oxide|E|30.01 |
|NO2|Nitrogen Dioxide|E|46.01 |
|NO3|Nitrate Radical|E|62.01 |
|NPHE|Nitrophenols|E|139.11 |
|O1D|Excited Oxygen Atoms|E|16 |
|O3|Ozone|E|48 |
|O3P|Ground State Oxygen Atoms|E|16 |
|OH|Hydroxyl Radicals|E|17.01 |
|OLE1|Alkenes (other than ethene) with kOH < 7x104 ppm-1 min-1.|L|72.34 |
|OLE2|Alkenes with kOH > 7x104 ppm-1 min-1.|L|75.78 |
|OXYL|o-xylene|E|106.17 |
|PAHHRXN|Precursor of Hydro-PAH Aerosol Material|L|187.2 |
|PAHNRXN|Precursor of Nitro-PAH Aerosol Material|L|187.2 |
|PAHRO2|PAH hydroxyperoxy radicals|L|187.2 |
|PAN|Peroxy Acetyl Nitrate|E|121.05 |
|PAN2|PPN and other higher alkyl PAN analogues|L|135.08 |
|PBZN|PAN analogues formed from Aromatic Aldehydes|L|183.13 |
|PRD2|Ketones and other non-aldehyde oxygenated products which react with OH radicals faster than 5 x 10-12 cm3 molec-2 sec-1.||116.16 |
|PROPENE|propene|L|42.08 |
|PROPNN|propanone nitrate from isoprene + OH|L|119.1 |
|PXYL|p-xylene|E|106.17 |
|PYRUACD|Pyruvic Acid|E|88.1 |
|R6OOH|Lumped organic hydroperoxides with 5 or more carbons (other than those formed following OH addition to aromatic rings, which is reprsented separately). Mechanism based on that estimated for 3-hexyl hydroperoxide.|L|118.17 |
|RAOOH|Organic hydroperoxides formed following OH addition to aromatic rings, which is reprsented separately because of their probable role in SOA formation. Mechanism based on two isomers expected to be formed in the m-xylene system.|L|188.18 |
|RCHO|Lumped C3+ Aldehydes (mechanism based on propionaldehyde)|L|58.08 |
|RCO3|Peroxy Propionyl and higher peroxy acyl Radicals|L|89.07 |
|RCOOH|Higher organic acids and, in Carter, peroxy acids (mechanism based on propionic acid).|L|74.08 |
|RCOOOH|Proposed Higher organic peroxy acids|L|74.08 |
|RNO3|Lumped Organic Nitrates|L|147.18 |
|RNO3I|Lumped Organic Nitrates from isoprene|L|147.18 |
|RO2C|Peroxy Radical Operator representing NO to NO2 and NO3 to NO2 conversions, and the effects of peroxy radical reactions on acyl peroxy and other peroxy radicals.|L|1 |
|RO2XC|Peroxy Radical Operator representing NO consumption (used in conjunction with organic nitrate formation), and the effects of peroxy radical reactions on NO3, acyl peroxy radicals, and other peroxy radicals.|L|1 |
|ROOH|Lumped organic hydroperoxides with 2-4 carbons. Mechanism based on that estimated for n-propyl hydroperoxide.||76.1 |
|SESQ|Sesquiterpenes|L|204.35 |
|SESQRXN|Precursor of Sesquiterpenes Aerosol Material|L|204.35 |
|SO2|Sulfur Dioxide|E|64.06 |
|SOAALK|Alkanes that produce aerosol material|L|112 |
|SULF|Sulfates (SO3 or H2SO4)|L|98.08 |
|SULRXN|Precursor of Aerosol Sulfate|L|98.08 |
|TBUO|t-Butoxy Radicals|L|73 |
|TERP|Terpenes|L|136.24 |
|TERPNRO2|TERP+NO3 peroxy radical|L|197 |
|TMBENZ124|1,2,4-trimethyl benzene|E|120.19 |
|TOLHRXN|Precursor of Hydro-Toulene Aerosol Material|L|172.14 |
|TOLNRXN|Precursor of Nitro-Toulene Aerosol Material|L|172.14 |
|TOLRO2|Peroxy Radical tracker from TOLUENE and ARO1 reactions with OH; an aerosol precursor|L|172.14 |
|TOLUENE|toluene|E|92.14 |
|TRPRXN|Precursor of Terpene Aerosol Material|E|136 |
|xACETONE|ACETONE production operator via reaction with Peroxy, Acetyl Peroxy, their operators, NO or NO3 Radicals (yield vary based on radical)|L|58.08 |
|xACROLEIN|ACROLEIN production operator via reaction with Peroxy, Acetyl Peroxy, their operators, NO or NO3 Radicals (yield vary based on radical)|L|56.06 |
|xAFG1|AFG1 production operator via reaction with Peroxy, Acetyl Peroxy, their operators, NO or NO3 Radicals (yield vary based on radical)|L|98.1 |
|xAFG2|AFG2 production operator via reaction with Peroxy, Acetyl Peroxy, their operators, NO or NO3 Radicals (yield vary based on radical)|L|98.1 |
|xAFG3|AFG3 production operator via reaction with Peroxy, Acetyl Peroxy, their operators, NO or NO3 Radicals (yield vary based on radical)|L|124.74 |
|xBACL|BACL production operator via reaction with Peroxy, Acetyl Peroxy, their operators, NO or NO3 Radicals (yield vary based on radical)|L|86.09 |
|xBALD|BALD production operator via reaction with Peroxy, Acetyl Peroxy, their operators, NO or NO3 Radicals (yield vary based on radical)|L|106.13 |
|xCCHO|CCHO production operator via reaction with Peroxy, Acetyl Peroxy, their operators, NO or NO3 Radicals (yield vary based on radical)|L|44.05 |
|xCL|Cl production operator via reaction with Peroxy, Acetyl Peroxy, their operators, NO or NO3 Radicals (yield vary based on radical)|L|35.5 |
|xCLACET|CLACET production operator via reaction with Peroxy, Acetyl Peroxy, their operators, NO or NO3 Radicals (yield vary based on radical)|L|92.5 |
|xCLCCHO|CLCCHO production operator via reaction with Peroxy, Acetyl Peroxy, their operators, NO or NO3 Radicals (yield vary based on radical)|L|78.5 |
|xCO|CO production operator via reaction with Peroxy, Acetyl Peroxy, their operators, NO or NO3 Radicals (yield vary based on radical)|L|28.01 |
|xGLY|GLY production operator via reaction with Peroxy, Acetyl Peroxy, their operators, NO or NO3 Radicals (yield vary based on radical)||58.04 |
|xHCHO|HCHO production operator via reaction with Peroxy, Acetyl Peroxy, their operators, NO or NO3 Radicals (yield vary based on radical)|L|30.03 |
|xHO2|Formation of HO2 from alkoxy radicals formed in peroxy radical reactions with NO and NO3 (100% yields) and RO2 (50% yields)|L|33.01 |
|xHOCCHO|HOCCHO production operator via reaction with Peroxy, Acetyl Peroxy, their operators, NO or NO3 Radicals (yield vary based on radical)|L|60.05 |
|xIPRD|IPRD production operator via reaction with Peroxy, Acetyl Peroxy, their operators, NO or NO3 Radicals (yield vary based on radical)|L|100.12 |
|xMACO3|MACO3 production operator via reaction with Peroxy, Acetyl Peroxy, their operators, NO or NO3 Radicals (yield vary based on radical)|L|101.08 |
|xMACR|MACR production operator via reaction with Peroxy, Acetyl Peroxy, their operators, NO or NO3 Radicals (yield vary based on radical)|L|70.09 |
|xMECO3|MECO3 production operator via reaction with Peroxy, Acetyl Peroxy, their operators, NO or NO3 Radicals (yield vary based on radical)|L|75.04 |
|xMEK|MEK production operator via reaction with Peroxy, Acetyl Peroxy, their operators, NO or NO3 Radicals (yield vary based on radical)|L|72.11 |
|xMEO2|MEO2 production operator via reaction with Peroxy, Acetyl Peroxy, their operators, NO or NO3 Radicals (yield vary based on radical)|L|47.03 |
|xMGLY|MGLY production operator via reaction with Peroxy, Acetyl Peroxy, their operators, NO or NO3 Radicals (yield vary based on radical)|L|72.07 |
|xMTNO3|MGLY production operator via reaction with Peroxy, Acetyl Peroxy, their operators, NO or NO3 Radicals (yield vary based on radical)|L|231 |
|xMVK|MVK production operator via reaction with Peroxy, Acetyl Peroxy, their operators, NO or NO3 Radicals (yield vary based on radical)|L|70.09 |
|xNO2|NO2 production operator via reaction with Peroxy, Acetyl Peroxy, their operators, NO or NO3 Radicals (yield vary based on radical)|L|46.01 |
|xOH|OH production operator via reaction with Peroxy, Acetyl Peroxy, their operators, NO or NO3 Radicals (yield vary based on radical)|L|17.01 |
|xPROD2|PROD2 production operator via reaction with Peroxy, Acetyl Peroxy, their operators, NO or NO3 Radicals (yield vary based on radical)|L|116.16 |
|xRCHO|RCHO production operator via reaction with Peroxy, Acetyl Peroxy, their operators, NO or NO3 Radicals (yield vary based on radical)|L|58.08 |
|xRCO3|RCO3 production operator via reaction with Peroxy, Acetyl Peroxy, their operators, NO or NO3 Radicals (yield vary based on radical)|L|89.07 |
|xRNO3|RNO3 production operator via reaction with Peroxy, Acetyl Peroxy, their operators, NO or NO3 Radicals (yield vary based on radical)|L|147.18 |
|xTBUO|TBUO production operator via reaction with Peroxy, Acetyl Peroxy, their operators, NO or NO3 Radicals (yield vary based on radical)|L|73 |
|XYLHRXN|Precursor of Hydro-Xylene Aerosol Material|L|187.17 |
|XYLNRXN|Precursor of Nitro-Xylene Aerosol Material|L|187.17 |
|XYLRO2|Peroxy Radical tracker from xylene and ARO2 reactions with OH;an aerosol precursor|L|187.17 |
|yR6OOH|R6OOH production operator via reaction with Peroxy, Acetyl Peroxy, their operators, NO or NO3 Radicals (yield vary based on radical)|L|118.17 |
|yRAOOH|RAOOH production operator via reaction with Peroxy, Acetyl Peroxy, their operators, NO or NO3 Radicals (yield vary based on radical)|L|188.18 |
|yROOH|ROOH production operator via reaction with Peroxy, Acetyl Peroxy, their operators, NO or NO3 Radicals (yield vary based on radical)|L|76.1 |
|zMTNO3|ROOH production operator via reaction with Peroxy, Acetyl Peroxy, their operators, NO or NO3 Radicals (yield vary based on radical)|L|231 |
|zRNO3|RNO3 production operator via reaction with Peroxy, Acetyl Peroxy, their operators, NO or NO3 Radicals (yield vary based on radical)|L|147.18 |


**The AE namelist for saprc07tic_ae6i_aq has the following aerosol species.**

| **Model Species** | **Definition**                                             | **Molecular Weight** | **Explicit or Lumped** |
| ----------------- | ---------------------------------------------------- | -------------------- | ---------------------- |
| AAL               | Aluminum                                             | 27                   | E                      |
| AALK1             | Semivolaitle SOA Product from Alkane VOCs            | 225.0                | L                      |
| AALK2             | Semivolatile SOA Product from Alkane VOCs            | 205.1                | L                      |
| ABNZ1             | Semivolatile High-NOx SOA Product from Benzene       | 161.0                | L                      |
| ABNZ2             | Semivolatile High-NOx SOA Product from Benzene       | 134.0                | L                      |
| ABNZ3             | Low-Volatility Low-NOx SOA Product from Benzene      | 180.0                | L                      |
| ACA               | Calcium                                              | 40.1                 | E                      |
| ACL               | Chloride                                             | 35.5                 | E                      |
| ACORS             | Anthropogenic Coarse-mode particle mass              | 100.0                | L                      |
| ADIM              | IEPOX-derived dimers                                 | 248.23               | L                      |
| AEC               | Elemental Carbon                                     | 12                   | E                      |
| AFE               | Iron                                                 | 55.8                 | E                      |
| AGLY              | Glyoxal and Methylglyoxal SOA in aqueous aerosol material                       | 66.4                 | L                      |
| AH2O              | Water                                                | 18                   | E                      |
| AH3OP             | Hydronium Ion                                        | 19                   | E                      |
| AIEOS             | IEPOX-derived organosulfate                          | 216.20               | L                      |
| AIETET            | 2-methyltetrols                                      | 136.15               | L                      |
| AIMGA             | 2-methylglyceric acid                                | 120.10               | L                      |
| AIMOS             | MPAN-derived organosulfate                           | 200.16               | L                      |
| AISO1             | Semivolatile SOA Product from Isoprene               | 132.0                | L                      |
| AISO2             | High-Volatility SOA Product from Isoprene            | 133.0                | L                      |
| AISO3             | Acid-catalyzed Isoprene Epoxydiol SOA                | 168.2                | L                      |
| AISOPNN           | Isoprene Dinitrates                                  | 226                  | L                      |
| AIVPO1            | Intermediate Volatility Primary Organic Compounds    | 266                  | L                      |
| AK                | Potassium                                            | 39.1                 | E                      |
| ALVOO1            | Low Volatility Oxidized Combustion Organic Compounds | 136                  | L                      |
| ALVOO2            | Low Volatility Oxidized Combustion Organic Compounds | 136                  | L                      |
| ALVPO1            | Low Volatility Primary Organic Compounds             | 218                  | L                      |
| AMG               | Magnesium                                            | 24.3                 | E                      |
| AMN               | Manganese                                            | 54.9                 | E                      |
| AMTHYD            | Organic Nitrate Hydrolysis Product                   | 185                  | L                      |
| AMTNO3            | Monoterpene Nitrates                                 | 231                  | L                      |
| ANA               | Sodium                                               | 23                   | E                      |
| ANH4              | Ammonium                                             | 18                   | E                      |
| ANO3              | Nitrate                                              | 62                   | E                      |
| AOLGA             | Oligomer products of anthropogenic SOA compounds     | 206.0                | L                      |
| AOLGB             | Oligomer products of biogenic SOA compounds          | 248.0                | L                      |
| AORGC             | Glyoxal and methylglyoxal SOA produced in cloud water                        | 177.0                | L                      |
| AOTHR             | Other Particulate Mass                               | 200                  | L                      |
| APAH1             | Semivolatile High-NOx SOA Product from PAHs          | 195.6                | L                      |
| APAH2             | Semivolatile High-NOx  SOA Product from PAHs         | 178.7                | L                      |
| APAH3             | Low-Volatility Low-NOx SOA Product from PAHs         | 212.2                | L                      |
| APCSO             | Potential Combustion SOA                             | 170                  | L                      |
| APNCOM            | Non-Carbon Organic Matter associated with APOC       | 220.0                | L                      |
| APOC              | Primary Organic Carbon                               | 220.0                | L                      |
| ASEACAT           | Sea spray cations                                    | 23.75                | L                      |
| ASI               | Silicon                                              | 28.1                 | E                      |
| ASO4              | Sulfate                                              | 96                   | E                      |
| ASOIL             | Lumped crustal species                               | 100.0                | L                      |
| ASQT              | Semivolatile SOA Product from Sesquiterpenes         | 273.0                | L                      |
| ASVOO1            | Semivolatile Oxidized Combustion Organic Compounds   | 135                  | L                      |
| ASVOO2            | Semivolatile Oxidized Combustion Organic Compounds   | 135                  | L                      |
| ASVOO3            | Semivolatile Oxidized Combustion Organic Compounds   | 134                  | L                      |
| ASVPO1            | Semivolatile Primary Organic Compounds               | 230                  | L                      |
| ASVPO2            | Semivolatile Primary Organic Compounds               | 241                  | L                      |
| ASVPO3            | Semivolatile Primary Organic Compounds               | 253                  | L                      |
| ATI               | Titanium                                             | 47.9                 | E                      |
| ATOL1             | Semivolatile High-NOx SOA Product from Toluene       | 163.0                | L                      |
| ATOL2             | Semivolaitle High-NOx SOA Product from Toluene       | 175.0                | L                      |
| ATOL3             | Low-Volatility Low-NOx SOA Product from Toluene      | 194.0                | L                      |
| ATRP1             | Semivolatile SOA Product from Monoterpenes           | 177.0                | L                      |
| ATRP2             | High-Volatility SOA Product from Monoterpenes        | 198.0                | L                      |
| AXYL1             | Semivolatile High-NOx SOA Product from Xylene        | 174.0                | L                      |
| AXYL2             | Semivolaitle High-NOx SOA Product from Xylene        | 185.0                | L                      |
| AXYL3             | Low-Volatility Low-NOx SOA Product from Xylene       | 218.0                | L                      |
| NUMACC            | Accum. Mode Number Conc                              | NA                   | NA                     |
| NUMAIT            | Aitken Mode Number Conc                              | NA                   | NA                     |
| NUMCOR            | Coarse Mode Number Conc                              | NA                   | NA                     |
| SRFACC            | Accum. Mode Surface Area Conc                        | NA                   | NA                     |
| SRFAIT            | Aitken Mode Surface Area Conc                        | NA                   | NA                     |
| SRFCOR            | Coarse Mode Surface Area Conc                        | NA                   | NA                     |

Note that for each aerosol mass species, a letter will be appended to the names below in order to designate the size, or mode, of the aerosol being represented: I = Aitken mode, J = Accumulation mode, K = Coarse mode.  

**The NR namelist for sapr07tic_ae6i_aq has the following gas phase species.**

| **Model Species** | **Definition**                                             | **Molecular Weight** | **Explicit or Lumped** |
| ----------------- | ---------------------------------------------------- | -------------------- | ---------------------- |
|  LVPCSOG          | surrogate SOA precursor gas for combustion/anthropogenic sources            | 170.0  |  L  |  
|  NH3              |  ammonia                                                    |  17.0  |  E  |      
|  SVALK1           |  vapors of secondary aerosol material from alkane VOCs      | 225.0  |  L  |     
|  SVALK2           |  vapors of secondary aerosol material from alkane VOCs      | 205.1  |  L  |     
|  SVXYL1           |  vapors of secondary aerosol material from xylenes          | 174.0  |  L  |  
|  SVXYL2           |  vapors of secondary aerosol material from xylenes          | 185.0  |  L  |  
|  SVTOL1           |  vapors of secondary aerosol material from toluene          | 163.0  |  L  |  
|  SVTOL2           |  vapors of secondary aerosol material from toluene          | 175.0  |  L  |  
|  SVBNZ1           |  vapors of secondary aerosol material from benzene          | 161.0  |  L  |  
|  SVBNZ2           |  vapors of secondary aerosol material from benzene          | 134.0  |  L  |  
|  SVPAH1           |  vapors of secondary aerosol material from PAHs             | 195.6  |  L  |  
|  SVPAH2           |  vapors of secondary aerosol material from PAHs             | 178.7  |  L  |  
|  SVTRP1           |  vapors of secondary aerosol material from monoterpenes     | 177.0  |  L  |      
|  SVTRP2           |  vapors of secondary aerosol material from monoterpenes     | 198.0  |  L  |      
|  SVISO1           |  vapors of secondary aerosol material from isoprene         | 132.0  |  L  |  
|  SVISO2           |  vapors of secondary aerosol material from isoprene         | 133.0  |  L  |  
|  SVSQT            |  vapors of secondary aerosol material from sesquiterpenes   | 273.0  |  L  |         
