
!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!
 
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
! 
! Sparse Jacobian Data Structures File
! 
! Generated by KPP-2.2.3 symbolic chemistry Kinetics PreProcessor
!       (http://www.cs.vt.edu/~asandu/Software/KPP)
! KPP is distributed under GPL, the general public licence
!       (http://www.gnu.org/copyleft/gpl.html)
! (C) 1995-1997, V. Damian & A. Sandu, CGRER, Univ. Iowa
! (C) 1997-2005, A. Sandu, Michigan Tech, Virginia Tech
!     With important contributions from:
!        M. Damian, Villanova University, USA
!        R. Sander, Max-Planck Institute for Chemistry, Mainz, Germany
! 
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~



MODULE aqchem_JacobianSP

  PUBLIC
  SAVE


! Sparse Jacobian Data


  INTEGER, PARAMETER, DIMENSION(243) :: LU_IROW = (/ &
       1,  2,  3,  4,  5,  6,  7,  8,  9,  9, 10, 10, &
      11, 11, 12, 13, 14, 15, 16, 17, 17, 18, 18, 18, &
      18, 19, 19, 20, 20, 20, 20, 21, 21, 22, 22, 23, &
      23, 24, 24, 24, 25, 25, 26, 26, 27, 27, 27, 27, &
      28, 28, 29, 29, 30, 30, 31, 31, 32, 32, 33, 33, &
      34, 34, 35, 35, 36, 36, 37, 37, 38, 38, 39, 39, &
      39, 40, 40, 41, 41, 42, 42, 43, 43, 44, 44, 45, &
      45, 46, 46, 47, 47, 48, 48, 49, 49, 50, 50, 51, &
      51, 52, 52, 53, 53, 54, 54, 55, 55, 56, 56, 57, &
      57, 58, 58, 59, 59, 60, 60, 60, 60, 61, 61, 61, &
      61, 62, 62, 62, 62, 63, 63, 63, 63, 64, 64, 64, &
      64, 65, 65, 65, 65, 66, 66, 66, 67, 67, 67, 68, &
      68, 68, 68, 69, 69, 69, 69, 70, 70, 70, 71, 71, &
      71, 71, 72, 72, 72, 72, 73, 73, 73, 73, 74, 74, &
      74, 74, 75, 75, 75, 75, 76, 76, 76, 76, 76, 76, &
      76, 76, 76, 76, 76, 76, 76, 77, 77, 77, 77, 78, &
      78, 78, 78, 78, 78, 79, 79, 79, 79, 79, 79, 79, &
      79, 79, 79, 79, 79, 79, 79, 79, 79, 79, 79, 79, &
      79, 79, 79, 79, 80, 80, 80, 80, 80, 80, 81, 81, &
      81, 81, 81, 81, 81, 81, 81, 81, 82, 82, 82, 82, &
      82, 82, 82 /)

  INTEGER, PARAMETER, DIMENSION(243) :: LU_ICOL = (/ &
       1,  2,  3,  4,  5,  6,  7,  8,  8,  9,  6, 10, &
       7, 11, 12, 13, 14, 15, 16,  4, 17, 18, 78, 81, &
      82, 19, 60, 20, 70, 71, 72, 21, 62, 22, 74, 23, &
      80, 24, 65, 66, 25, 77, 26, 75, 27, 67, 73, 76, &
      28, 68, 29, 53, 30, 55, 31, 61, 32, 63, 33, 69, &
       9, 34, 12, 35, 13, 36, 10, 37, 38, 39, 39, 53, &
      55, 11, 40, 41, 79, 14, 42, 15, 43, 16, 44, 17, &
      45, 46, 60, 47, 71, 48, 62, 49, 74, 50, 80, 51, &
      65, 52, 77, 53, 54, 53, 54, 55, 56, 55, 56, 57, &
      75, 58, 68, 59, 82, 46, 60, 61, 79,  1, 60, 61, &
      79, 48, 62, 63, 64,  2, 62, 63, 64, 62, 63, 64, &
      79, 51, 65, 66, 79, 65, 66, 79, 67, 73, 79, 58, &
      68, 69, 79,  3, 68, 69, 79, 70, 72, 79, 47, 71, &
      72, 79, 70, 71, 72, 79, 67, 73, 76, 79, 49, 74, &
      79, 81, 57, 75, 79, 81,  5, 12, 13, 73, 74, 75, &
      76, 77, 78, 79, 80, 81, 82, 52, 77, 79, 81, 12, &
      13, 78, 79, 80, 81, 12, 13, 60, 61, 64, 65, 66, &
      67, 68, 69, 70, 71, 72, 73, 74, 75, 76, 77, 78, &
      79, 80, 81, 82, 50, 78, 79, 80, 81, 82, 12, 13, &
      74, 75, 77, 78, 79, 80, 81, 82, 12, 13, 59, 79, &
      80, 81, 82 /)

  INTEGER, PARAMETER, DIMENSION(83) :: LU_CROW = (/ &
       1,  2,  3,  4,  5,  6,  7,  8,  9, 11, 13, 15, &
      16, 17, 18, 19, 20, 22, 26, 28, 32, 34, 36, 38, &
      41, 43, 45, 49, 51, 53, 55, 57, 59, 61, 63, 65, &
      67, 69, 71, 74, 76, 78, 80, 82, 84, 86, 88, 90, &
      92, 94, 96, 98,100,102,104,106,108,110,112,114, &
     118,122,126,130,134,138,141,144,148,152,155,159, &
     163,167,171,175,188,192,198,221,227,237,244 /)

  INTEGER, PARAMETER, DIMENSION(83) :: LU_DIAG = (/ &
       1,  2,  3,  4,  5,  6,  7,  8, 10, 12, 14, 15, &
      16, 17, 18, 19, 21, 22, 26, 28, 32, 34, 36, 38, &
      41, 43, 45, 49, 51, 53, 55, 57, 59, 62, 64, 66, &
      68, 69, 71, 75, 76, 79, 81, 83, 85, 86, 88, 90, &
      92, 94, 96, 98,100,103,104,107,108,110,112,115, &
     120,123,128,132,135,139,141,145,150,152,156,161, &
     164,168,172,181,189,194,217,224,235,243,244 /)


END MODULE aqchem_JacobianSP

