
!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!
 
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
! 
! Sparse Jacobian Data Structures File
! 
! Generated by KPP-2.2.3 symbolic chemistry Kinetics PreProcessor
!       (http://www.cs.vt.edu/~asandu/Software/KPP)
! KPP is distributed under GPL, the general public licence
!       (http://www.gnu.org/copyleft/gpl.html)
! (C) 1995-1997, V. Damian & A. Sandu, CGRER, Univ. Iowa
! (C) 1997-2005, A. Sandu, Michigan Tech, Virginia Tech
!     With important contributions from:
!        M. Damian, Villanova University, USA
!        R. Sander, Max-Planck Institute for Chemistry, Mainz, Germany
! 
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~



MODULE aqchem_JacobianSP

  PUBLIC
  SAVE


! Sparse Jacobian Data


  INTEGER, PARAMETER, DIMENSION(295) :: LU_IROW = (/ &
       1,  2,  3,  4,  5,  6,  7,  8,  9,  9, 10, 10, &
      11, 11, 12, 13, 14, 15, 16, 17, 17, 18, 18, 18, &
      18, 19, 19, 20, 20, 20, 20, 21, 21, 22, 22, 23, &
      23, 24, 24, 24, 25, 25, 26, 26, 27, 27, 27, 27, &
      28, 28, 29, 29, 30, 30, 31, 31, 32, 32, 33, 33, &
      34, 34, 35, 35, 36, 36, 37, 37, 38, 38, 39, 39, &
      39, 40, 40, 41, 41, 42, 42, 43, 43, 44, 44, 45, &
      45, 46, 46, 47, 47, 48, 48, 49, 49, 50, 50, 50, &
      50, 51, 51, 52, 52, 53, 53, 54, 54, 54, 55, 55, &
      56, 56, 56, 56, 57, 57, 58, 58, 59, 59, 59, 60, &
      60, 61, 61, 61, 62, 62, 63, 63, 64, 64, 65, 65, &
      66, 66, 67, 67, 68, 68, 69, 69, 70, 70, 71, 71, &
      72, 72, 73, 73, 74, 74, 75, 75, 76, 76, 77, 77, &
      77, 78, 78, 78, 78, 78, 79, 79, 79, 80, 80, 80, &
      80, 81, 81, 81, 81, 82, 82, 82, 83, 83, 83, 83, &
      84, 84, 84, 84, 85, 85, 85, 85, 86, 86, 86, 86, &
      87, 87, 87, 87, 88, 88, 88, 88, 89, 89, 89, 89, &
      90, 90, 90, 90, 91, 91, 91, 92, 92, 92, 92, 93, &
      93, 93, 93, 94, 94, 94, 94, 95, 95, 95, 95, 96, &
      96, 96, 96, 96, 96, 96, 96, 96, 96, 96, 96, 96, &
      96, 96, 96, 97, 97, 97, 97, 97, 97, 97, 98, 98, &
      98, 98, 98, 98, 98, 98, 98, 98, 99, 99, 99, 99, &
      99, 99,100,100,100,100,100,100,101,101,101,101, &
     101,101,101,101,101,101,101,101,101,101,101,101, &
     101,101,101,101,101,101,101 /)

  INTEGER, PARAMETER, DIMENSION(295) :: LU_ICOL = (/ &
       1,  2,  3,  4,  5,  6,  7,  8,  8,  9,  6, 10, &
       7, 11, 12, 13, 14, 15, 16,  4, 17, 18, 97, 98, &
      99, 19, 85, 20, 89, 90, 91, 21, 87, 22, 95, 23, &
     100, 24, 82, 83, 25, 94, 26, 93, 27, 79, 92, 96, &
      28, 80, 29, 67, 30, 69, 31, 84, 32, 86, 33, 81, &
       9, 34, 12, 35, 13, 36, 10, 37, 38, 39, 39, 67, &
      69, 11, 40, 41,101, 14, 42, 15, 43, 16, 44, 17, &
      45, 46, 78, 47, 57, 48, 77, 49, 50, 50, 57, 77, &
      78, 51, 59, 52, 61, 53, 54, 54, 59, 61, 55, 56, &
      56, 59, 61, 96, 57, 78, 58, 59, 58, 59, 96, 60, &
      61, 60, 61, 96, 62, 87, 63, 78, 64,100, 65, 83, &
      66, 94, 67, 68, 67, 68, 69, 70, 69, 70, 71, 93, &
      72, 80, 73, 97, 74, 85, 75, 89, 76, 95, 77, 78, &
      96, 57, 63, 77, 78, 96, 79, 92,101, 72, 80, 81, &
     101,  3, 80, 81,101, 82, 83,101, 65, 82, 83,101, &
       1, 84, 85,101, 74, 84, 85,101,  2, 86, 87, 88, &
      62, 86, 87, 88, 86, 87, 88,101, 75, 89, 90,101, &
      89, 90, 91,101, 90, 91,101, 79, 92, 96,101, 71, &
      93, 98,101, 66, 94, 98,101, 76, 95, 98,101,  5, &
      12, 13, 59, 61, 78, 92, 93, 94, 95, 96, 97, 98, &
      99,100,101, 12, 13, 73, 97, 98,100,101, 12, 13, &
      93, 94, 95, 97, 98, 99,100,101, 12, 13, 98, 99, &
     100,101, 64, 97, 98, 99,100,101, 12, 13, 79, 80, &
      81, 82, 83, 84, 85, 88, 89, 90, 91, 92, 93, 94, &
      95, 96, 97, 98, 99,100,101 /)

  INTEGER, PARAMETER, DIMENSION(102) :: LU_CROW = (/ &
       1,  2,  3,  4,  5,  6,  7,  8,  9, 11, 13, 15, &
      16, 17, 18, 19, 20, 22, 26, 28, 32, 34, 36, 38, &
      41, 43, 45, 49, 51, 53, 55, 57, 59, 61, 63, 65, &
      67, 69, 71, 74, 76, 78, 80, 82, 84, 86, 88, 90, &
      92, 94, 98,100,102,104,107,109,113,115,117,120, &
     122,125,127,129,131,133,135,137,139,141,143,145, &
     147,149,151,153,155,158,163,166,170,174,177,181, &
     185,189,193,197,201,205,209,212,216,220,224,228, &
     244,251,261,267,273,296 /)

  INTEGER, PARAMETER, DIMENSION(102) :: LU_DIAG = (/ &
       1,  2,  3,  4,  5,  6,  7,  8, 10, 12, 14, 15, &
      16, 17, 18, 19, 21, 22, 26, 28, 32, 34, 36, 38, &
      41, 43, 45, 49, 51, 53, 55, 57, 59, 62, 64, 66, &
      68, 69, 71, 75, 76, 79, 81, 83, 85, 86, 88, 90, &
      92, 94, 98,100,102,104,107,109,113,115,118,120, &
     123,125,127,129,131,133,135,138,139,142,143,145, &
     147,149,151,153,155,161,163,167,172,174,179,182, &
     187,190,195,199,202,206,210,213,217,221,225,238, &
     247,257,264,271,295,296 /)


END MODULE aqchem_JacobianSP

