
!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!
 
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
! 
! Sparse Jacobian Data Structures File
! 
! Generated by KPP-2.2.3 symbolic chemistry Kinetics PreProcessor
!       (http://www.cs.vt.edu/~asandu/Software/KPP)
! KPP is distributed under GPL, the general public licence
!       (http://www.gnu.org/copyleft/gpl.html)
! (C) 1995-1997, V. Damian & A. Sandu, CGRER, Univ. Iowa
! (C) 1997-2005, A. Sandu, Michigan Tech, Virginia Tech
!     With important contributions from:
!        M. Damian, Villanova University, USA
!        R. Sander, Max-Planck Institute for Chemistry, Mainz, Germany
! 
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~



MODULE aqchem_JacobianSP

  PUBLIC
  SAVE


! Sparse Jacobian Data


  INTEGER, PARAMETER, DIMENSION(306) :: LU_IROW = (/ &
       1,  2,  3,  4,  5,  6,  7,  8,  9,  9, 10, 10, &
      11, 11, 12, 13, 14, 15, 16, 17, 17, 18, 18, 18, &
      18, 19, 19, 20, 20, 20, 20, 21, 21, 22, 22, 23, &
      23, 24, 24, 24, 25, 25, 26, 26, 27, 27, 27, 27, &
      28, 28, 29, 29, 30, 30, 31, 31, 32, 32, 33, 33, &
      34, 34, 35, 35, 36, 36, 37, 37, 38, 38, 39, 39, &
      39, 40, 40, 41, 41, 42, 42, 43, 43, 44, 44, 45, &
      45, 46, 46, 47, 47, 48, 48, 49, 49, 50, 50, 51, &
      51, 52, 52, 53, 53, 54, 54, 55, 55, 56, 56, 57, &
      57, 58, 58, 59, 59, 60, 60, 61, 61, 62, 62, 63, &
      63, 64, 64, 65, 65, 66, 66, 67, 67, 68, 68, 69, &
      69, 70, 70, 71, 71, 71, 71, 72, 72, 72, 72, 73, &
      73, 73, 73, 74, 74, 74, 74, 75, 75, 75, 75, 76, &
      76, 76, 76, 77, 77, 77, 77, 78, 78, 78, 79, 79, &
      79, 80, 80, 80, 80, 81, 81, 81, 81, 82, 82, 82, &
      83, 83, 83, 83, 84, 84, 84, 84, 85, 85, 85, 85, &
      86, 86, 86, 86, 87, 87, 87, 87, 88, 88, 88, 88, &
      88, 88, 88, 88, 88, 88, 88, 88, 88, 89, 89, 89, &
      89, 90, 90, 90, 90, 90, 90, 90, 91, 91, 91, 91, &
      91, 91, 92, 92, 92, 92, 92, 92, 93, 93, 93, 93, &
      93, 93, 93, 93, 93, 93, 94, 94, 94, 94, 94, 94, &
      95, 95, 95, 95, 95, 95, 95, 96, 96, 96, 96, 96, &
      96, 96, 97, 97, 97, 97, 97, 97, 98, 98, 98, 98, &
      98, 98, 98, 98, 98, 98, 98, 98, 98, 98, 98, 98, &
      98, 98, 98, 98, 98, 98, 98, 98, 98, 98, 98, 98, &
      98, 99, 99, 99, 99, 99 /)

  INTEGER, PARAMETER, DIMENSION(306) :: LU_ICOL = (/ &
       1,  2,  3,  4,  5,  6,  7,  8,  8,  9,  6, 10, &
       7, 11, 12, 13, 14, 15, 16,  4, 17, 18, 90, 92, &
      93, 19, 71, 20, 73, 81, 82, 21, 74, 22, 87, 23, &
      91, 24, 77, 78, 25, 89, 26, 86, 27, 79, 83, 88, &
      28, 80, 29, 67, 30, 53, 31, 72, 32, 75, 33, 94, &
       9, 34, 12, 35, 13, 36, 10, 37, 38, 39, 39, 53, &
      67, 11, 40, 41, 98, 14, 42, 15, 43, 16, 44, 17, &
      45, 46, 84, 47, 96, 48, 99, 49, 85, 50, 95, 51, &
      97, 52, 53, 52, 53, 54, 84, 55, 96, 56, 99, 57, &
      85, 58, 95, 59, 90, 60, 71, 61, 73, 62, 74, 63, &
      87, 64, 91, 65, 77, 66, 89, 67, 68, 67, 68, 69, &
      86, 70, 80, 60, 71, 72, 98,  1, 71, 72, 98, 61, &
      73, 81, 98, 62, 74, 75, 76,  2, 74, 75, 76, 74, &
      75, 76, 98, 65, 77, 78, 98, 77, 78, 98, 79, 83, &
      98, 70, 80, 94, 98, 73, 81, 82, 98, 81, 82, 98, &
      79, 83, 88, 98, 54, 84, 97, 98, 57, 85, 97, 98, &
      69, 86, 93, 98, 63, 87, 93, 98,  5, 12, 13, 83, &
      86, 87, 88, 89, 90, 91, 92, 93, 98, 66, 89, 93, &
      98, 12, 13, 59, 90, 91, 93, 98, 64, 90, 91, 92, &
      93, 98, 12, 13, 91, 92, 93, 98, 12, 13, 86, 87, &
      89, 90, 91, 92, 93, 98,  3, 80, 94, 95, 96, 98, &
      58, 85, 94, 95, 96, 97, 98, 55, 94, 95, 96, 97, &
      98, 99, 84, 85, 96, 97, 98, 99, 12, 13, 71, 72, &
      73, 76, 77, 78, 79, 80, 81, 82, 83, 84, 85, 86, &
      87, 88, 89, 90, 91, 92, 93, 94, 95, 96, 97, 98, &
      99, 56, 96, 97, 98, 99 /)

  INTEGER, PARAMETER, DIMENSION(100) :: LU_CROW = (/ &
       1,  2,  3,  4,  5,  6,  7,  8,  9, 11, 13, 15, &
      16, 17, 18, 19, 20, 22, 26, 28, 32, 34, 36, 38, &
      41, 43, 45, 49, 51, 53, 55, 57, 59, 61, 63, 65, &
      67, 69, 71, 74, 76, 78, 80, 82, 84, 86, 88, 90, &
      92, 94, 96, 98,100,102,104,106,108,110,112,114, &
     116,118,120,122,124,126,128,130,132,134,136,140, &
     144,148,152,156,160,164,167,170,174,178,181,185, &
     189,193,197,201,214,218,225,231,237,247,253,260, &
     267,273,302,307 /)

  INTEGER, PARAMETER, DIMENSION(100) :: LU_DIAG = (/ &
       1,  2,  3,  4,  5,  6,  7,  8, 10, 12, 14, 15, &
      16, 17, 18, 19, 21, 22, 26, 28, 32, 34, 36, 38, &
      41, 43, 45, 49, 51, 53, 55, 57, 59, 62, 64, 66, &
      68, 69, 71, 75, 76, 79, 81, 83, 85, 86, 88, 90, &
      92, 94, 96, 98,101,102,104,106,108,110,112,114, &
     116,118,120,122,124,126,128,131,132,134,137,142, &
     145,149,154,158,161,165,167,171,175,179,182,186, &
     190,194,198,207,215,221,227,234,245,249,256,263, &
     270,300,306,307 /)


END MODULE aqchem_JacobianSP

