CMAQ Documentation
==================

This directory contains documentation for the [Community Multiscale Air Quality (CMAQ)](http://www.epa.gov/cmaq) modeling system.
While documentation is packaged with the code when it is downloaded or cloned, users are encouraged to go [online](https://github.com/USEPA/CMAQ/tree/master/DOCS) to view the latest version.

The following documents are available for the CMAQ v5.3.x release:

- [Release Notes](Release_Notes/README.md): Technical notes on the new features and science in this release of CMAQ.  

- [CMAQ User's Guide](Users_Guide/README.md): Instructions on how to set up and run the model and information on CMAQ's different science options and instrumented versions.

- [Tutorials](Users_Guide/Tutorials/README.md): Included with the User's Guide, a series of short tutorials provide practical examples of how to set up and run CMAQ, exercise different features in the software, and better understand the software system.

- [Chemical Mechanism Tables](../CCTM/src/MECHS/README.md): Tables of model species and chemical reactions in each chemical mechanism available in v5.3.

- [Known Issues](Known_Issues/README.md): A comprehensive list of the issues that have been identified and solved, but not incorporated, in the current release version of CMAQ. Recommended solutions are provided with each issue entry.

- [Developers' Guide](Developers_Guide/CMAQ_Dev_Guide.md): A guide to version control practices and expectations adopted by the CMAQ development team and enforced on itself and any other collaborators who wish to contribute code.


